package net.shadowfacts.cacao.view

import net.minecraft.client.util.math.MatrixStack
import net.shadowfacts.cacao.geometry.Point
import net.shadowfacts.cacao.util.RenderHelper
import net.shadowfacts.cacao.util.texture.Texture

/**
 * A helper class for drawing a [Texture] in a view.
 * `TextureView` will draw the given texture filling the bounds of the view.
 *
 * @author shadowfacts
 */
class TextureView(var texture: Texture?): View() {

	override fun drawContent(matrixStack: MatrixStack, mouse: Point, delta: Float) {
		texture?.also {
			RenderHelper.draw(matrixStack, bounds, it)
		}
	}

}
