package net.shadowfacts.cacao.geometry

import org.junit.jupiter.api.Assertions.*
import org.junit.jupiter.api.Test

/**
 * @author shadowfacts
 */
class RectTest {

	@Test
	fun testTrailingEdges() {
		val rect = Rect(25.0, 50.0, 100.0, 200.0)
		assertEquals(125.0, rect.right)
		assertEquals(250.0, rect.bottom)
	}

	@Test
	fun testCenter() {
		val rect = Rect(25.0, 50.0, 100.0, 200.0)
		assertEquals(75.0, rect.midX)
		assertEquals(150.0, rect.midY)

	}

	@Test
	fun testPoints() {
		val rect = Rect(25.0, 50.0, 100.0, 200.0)
		assertEquals(Point(25.0, 50.0), rect.origin)
		assertEquals(Point(75.0, 150.0), rect.center)
	}

	@Test
	fun testSize() {
		val rect = Rect(25.0, 50.0, 100.0, 200.0)
		assertEquals(Size(100.0, 200.0), rect.size)
	}

}